<template>
  <v-select
    v-model="inputValue"
    :options="options"
    :clearable="false"
    :searchable="false"
    :components="{ OpenIndicator: indicators[openIndicator] }"
    :class="[variant, { 'compact': compact }]"
    @input="onSelect"
  />
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
} from "@nuxtjs/composition-api";
import vSelect from "vue-select";
import SvgCaretDown from "@/assets/img/ui/caret-down.svg";
import SvgArrowheadDown from "@/assets/img/ui/arrowhead-down.svg";

export default defineComponent({
  components: {
    vSelect,
  },

  props: {
    selectId: {
      type: String,
      required: true,
    },
    options: {
      type: Array,
      required: true,
    },
    selectedOption: {
      type: Number || Boolean,
      default: 0,
      validator: value => value === false || typeof value === "number",
    },
    variant: {
      type: String,
      default: "outlined",
    },
    compact: {
      type: Boolean,
      default: false,
    },
    openIndicator: {
      type: String,
      default: "SvgCaretDown",
    },
  },

  setup (props: any, ctx: any) {
    const inputValue = ref(typeof props.selectedOption === "number" ? props.options[props.selectedOption] : "all");

    function onSelect ($event: Event) {
      ctx.emit("gotSelect", { $event, value: inputValue.value.value, id: props.selectId });
    }

    return {
      inputValue,
      onSelect,
    };
  },

  data () {
    return {
      indicators: {
        SvgCaretDown,
        SvgArrowheadDown,
      },
    };
  },
});
</script>

<style lang="postcss">
/* Overriding vue-select styling */
@import "@/node_modules/vue-select/dist/vue-select.css";

.v-select {
  height: 44px;

  @apply p-0 select-none;

  &[compact],
  &.compact {
    height: 2rem;
    font-size: 0.85rem;
  }

  .vs__selected-options {
    &.vs--open {
      .vs__open-indicator {
        transform: rotate(0deg);
      }
    }
  }

  .vs__search {
    padding-inline: 10px;

    @apply absolute m-0 py-1 w-full h-full;
  }

  .vs__dropdown-toggle {
    @apply border-none p-0 w-full h-full;
  }

  .vs__selected {
    color: inherit;

    @apply p-0;
  }

  .vs__dropdown-menu {
    transform: translate(0, 1.75px);
    border-style: solid;
    padding: 0;
    min-width: 100%;
    max-width: 320px;

    @apply absolute z-50 m-0 shadow-none border-1 border-black rounded-none p-0 w-auto;
  }

  .vs__dropdown-option {
    height: 2rem;

    @apply px-3 py-2;

    &--highlight {
      @apply bg-gray-200 text-black;
    }
  }

  &:disabled {
    @apply border-gray-200 bg-gray-200 text-gray-400;
  }

  &.outlined {
    @apply border-1 border-gray-600 m-0 p-0 bg-white leading-none;

    .vs__selected-options {
      @apply p-0 w-full;

      .vs__selected {
        padding-left: 10px;
        width: calc(100% - 30px);
        text-overflow: ellipsis;
        white-space: nowrap;

        @apply flex items-center m-0 p-0 h-full text-left overflow-hidden;
      }
    }

    .vs__actions {
      transform: translate(-5px, -1px);

      @apply absolute z-10 right-0 h-full text-black;

      .vs__clear {
        size: 30px;

        @apply flex justify-center items-center mr-0;
      }
    }

    &.vs--open,
    &:hover {
      @apply border-black border-1;
    }
  }

  &.underlined {
    @apply border-b-4 p-0 border-blue-700 text-blue-700;

    .vs__selected-options {
      @apply p-0;

      .vs__selected {
        margin-top: 4px;

        @apply relative m-0 text-blue-700;
      }
    }

    .vs__actions {
      padding: 4px 0 0 3px;
    }

    .vs__open-indicator {
      @apply text-blue-700 fill-current;
    }

    .vs__dropdown-menu {
      @apply text-sm font-normal;
    }
  }
}
</style>
